/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.1 on 2009-11-30 07:55:34,
 any modifications will be overwritten.
 ==============================================================
 */

package org.apache.maven.doxia.site.decoration.io.xpp3;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.io.Writer;
import java.text.DateFormat;
import java.util.Iterator;
import java.util.Locale;
import org.apache.maven.doxia.site.decoration.Banner;
import org.apache.maven.doxia.site.decoration.Body;
import org.apache.maven.doxia.site.decoration.DecorationModel;
import org.apache.maven.doxia.site.decoration.LinkItem;
import org.apache.maven.doxia.site.decoration.Logo;
import org.apache.maven.doxia.site.decoration.Menu;
import org.apache.maven.doxia.site.decoration.MenuItem;
import org.apache.maven.doxia.site.decoration.PublishDate;
import org.apache.maven.doxia.site.decoration.Skin;
import org.apache.maven.doxia.site.decoration.Version;
import org.codehaus.plexus.util.xml.Xpp3Dom;
import org.codehaus.plexus.util.xml.pull.MXSerializer;
import org.codehaus.plexus.util.xml.pull.XmlSerializer;

/**
 * Class DecorationXpp3Writer.
 * 
 * @version $Revision$ $Date$
 */
public class DecorationXpp3Writer
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field NAMESPACE.
     */
    private static final String NAMESPACE = null;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method write.
     * 
     * @param writer
     * @param decorationModel
     * @throws java.io.IOException
     */
    public void write( Writer writer, DecorationModel decorationModel )
        throws java.io.IOException
    {
        XmlSerializer serializer = new MXSerializer();
        serializer.setProperty( "http://xmlpull.org/v1/doc/properties.html#serializer-indentation", "  " );
        serializer.setProperty( "http://xmlpull.org/v1/doc/properties.html#serializer-line-separator", "\n" );
        serializer.setOutput( writer );
        serializer.startDocument( decorationModel.getModelEncoding(), null );
        writeDecorationModel( decorationModel, "project", serializer );
        serializer.endDocument();
    } //-- void write( Writer, DecorationModel )

    /**
     * Method writeBanner.
     * 
     * @param banner
     * @param serializer
     * @param tagName
     * @throws java.io.IOException
     */
    private void writeBanner( Banner banner, String tagName, XmlSerializer serializer )
        throws java.io.IOException
    {
        if ( banner != null )
        {
            serializer.startTag( NAMESPACE, tagName );
            if ( banner.getName() != null )
            {
                serializer.startTag( NAMESPACE, "name" ).text( banner.getName() ).endTag( NAMESPACE, "name" );
            }
            if ( banner.getSrc() != null )
            {
                serializer.startTag( NAMESPACE, "src" ).text( banner.getSrc() ).endTag( NAMESPACE, "src" );
            }
            if ( banner.getAlt() != null )
            {
                serializer.startTag( NAMESPACE, "alt" ).text( banner.getAlt() ).endTag( NAMESPACE, "alt" );
            }
            if ( banner.getHref() != null )
            {
                serializer.startTag( NAMESPACE, "href" ).text( banner.getHref() ).endTag( NAMESPACE, "href" );
            }
            if ( banner.getBorder() != null )
            {
                serializer.startTag( NAMESPACE, "border" ).text( banner.getBorder() ).endTag( NAMESPACE, "border" );
            }
            if ( banner.getWidth() != null )
            {
                serializer.startTag( NAMESPACE, "width" ).text( banner.getWidth() ).endTag( NAMESPACE, "width" );
            }
            if ( banner.getHeight() != null )
            {
                serializer.startTag( NAMESPACE, "height" ).text( banner.getHeight() ).endTag( NAMESPACE, "height" );
            }
            serializer.endTag( NAMESPACE, tagName );
        }
    } //-- void writeBanner( Banner, String, XmlSerializer )

    /**
     * Method writeBody.
     * 
     * @param body
     * @param serializer
     * @param tagName
     * @throws java.io.IOException
     */
    private void writeBody( Body body, String tagName, XmlSerializer serializer )
        throws java.io.IOException
    {
        if ( body != null )
        {
            serializer.startTag( NAMESPACE, tagName );
            if ( body.getHead() != null )
            {
                ((Xpp3Dom) body.getHead()).writeToSerializer( NAMESPACE, serializer );
            }
            if ( ( body.getLinks() != null ) && ( body.getLinks().size() > 0 ) )
            {
                serializer.startTag( NAMESPACE, "links" );
                for ( Iterator iter = body.getLinks().iterator(); iter.hasNext(); )
                {
                    LinkItem o = (LinkItem) iter.next();
                    writeLinkItem( o, "item", serializer );
                }
                serializer.endTag( NAMESPACE, "links" );
            }
            if ( ( body.getBreadcrumbs() != null ) && ( body.getBreadcrumbs().size() > 0 ) )
            {
                serializer.startTag( NAMESPACE, "breadcrumbs" );
                for ( Iterator iter = body.getBreadcrumbs().iterator(); iter.hasNext(); )
                {
                    LinkItem o = (LinkItem) iter.next();
                    writeLinkItem( o, "item", serializer );
                }
                serializer.endTag( NAMESPACE, "breadcrumbs" );
            }
            if ( ( body.getMenus() != null ) && ( body.getMenus().size() > 0 ) )
            {
                for ( Iterator iter = body.getMenus().iterator(); iter.hasNext(); )
                {
                    Menu o = (Menu) iter.next();
                    writeMenu( o, "menu", serializer );
                }
            }
            serializer.endTag( NAMESPACE, tagName );
        }
    } //-- void writeBody( Body, String, XmlSerializer )

    /**
     * Method writeDecorationModel.
     * 
     * @param decorationModel
     * @param serializer
     * @param tagName
     * @throws java.io.IOException
     */
    private void writeDecorationModel( DecorationModel decorationModel, String tagName, XmlSerializer serializer )
        throws java.io.IOException
    {
        if ( decorationModel != null )
        {
            serializer.setPrefix( "", "http://maven.apache.org/DECORATION/1.0.1" );
            serializer.setPrefix( "xsi", "http://www.w3.org/2001/XMLSchema-instance" );
            serializer.startTag( NAMESPACE, tagName );
            serializer.attribute( "", "xsi:schemaLocation", "http://maven.apache.org/DECORATION/1.0.1 http://maven.apache.org/xsd/decoration-1.0.1.xsd" );
            if ( decorationModel.getName() != null )
            {
                serializer.attribute( NAMESPACE, "name", decorationModel.getName() );
            }
            if ( decorationModel.getBannerLeft() != null )
            {
                writeBanner( (Banner) decorationModel.getBannerLeft(), "bannerLeft", serializer );
            }
            if ( decorationModel.getBannerRight() != null )
            {
                writeBanner( (Banner) decorationModel.getBannerRight(), "bannerRight", serializer );
            }
            if ( decorationModel.getPublishDate() != null )
            {
                writePublishDate( (PublishDate) decorationModel.getPublishDate(), "publishDate", serializer );
            }
            if ( decorationModel.getVersion() != null )
            {
                writeVersion( (Version) decorationModel.getVersion(), "version", serializer );
            }
            if ( ( decorationModel.getPoweredBy() != null ) && ( decorationModel.getPoweredBy().size() > 0 ) )
            {
                serializer.startTag( NAMESPACE, "poweredBy" );
                for ( Iterator iter = decorationModel.getPoweredBy().iterator(); iter.hasNext(); )
                {
                    Logo o = (Logo) iter.next();
                    writeLogo( o, "logo", serializer );
                }
                serializer.endTag( NAMESPACE, "poweredBy" );
            }
            if ( decorationModel.getSkin() != null )
            {
                writeSkin( (Skin) decorationModel.getSkin(), "skin", serializer );
            }
            if ( decorationModel.getBody() != null )
            {
                writeBody( (Body) decorationModel.getBody(), "body", serializer );
            }
            if ( decorationModel.getCustom() != null )
            {
                ((Xpp3Dom) decorationModel.getCustom()).writeToSerializer( NAMESPACE, serializer );
            }
            serializer.endTag( NAMESPACE, tagName );
        }
    } //-- void writeDecorationModel( DecorationModel, String, XmlSerializer )

    /**
     * Method writeLinkItem.
     * 
     * @param linkItem
     * @param serializer
     * @param tagName
     * @throws java.io.IOException
     */
    private void writeLinkItem( LinkItem linkItem, String tagName, XmlSerializer serializer )
        throws java.io.IOException
    {
        if ( linkItem != null )
        {
            serializer.startTag( NAMESPACE, tagName );
            if ( linkItem.getName() != null )
            {
                serializer.attribute( NAMESPACE, "name", linkItem.getName() );
            }
            if ( linkItem.getHref() != null )
            {
                serializer.attribute( NAMESPACE, "href", linkItem.getHref() );
            }
            if ( linkItem.getImg() != null )
            {
                serializer.attribute( NAMESPACE, "img", linkItem.getImg() );
            }
            if ( ( linkItem.getPosition() != null ) && !linkItem.getPosition().equals( "left" ) )
            {
                serializer.attribute( NAMESPACE, "position", linkItem.getPosition() );
            }
            if ( linkItem.getAlt() != null )
            {
                serializer.attribute( NAMESPACE, "alt", linkItem.getAlt() );
            }
            if ( linkItem.getBorder() != null )
            {
                serializer.attribute( NAMESPACE, "border", linkItem.getBorder() );
            }
            if ( linkItem.getWidth() != null )
            {
                serializer.attribute( NAMESPACE, "width", linkItem.getWidth() );
            }
            if ( linkItem.getHeight() != null )
            {
                serializer.attribute( NAMESPACE, "height", linkItem.getHeight() );
            }
            if ( linkItem.getTarget() != null )
            {
                serializer.attribute( NAMESPACE, "target", linkItem.getTarget() );
            }
            serializer.endTag( NAMESPACE, tagName );
        }
    } //-- void writeLinkItem( LinkItem, String, XmlSerializer )

    /**
     * Method writeLogo.
     * 
     * @param logo
     * @param serializer
     * @param tagName
     * @throws java.io.IOException
     */
    private void writeLogo( Logo logo, String tagName, XmlSerializer serializer )
        throws java.io.IOException
    {
        if ( logo != null )
        {
            serializer.startTag( NAMESPACE, tagName );
            if ( logo.getName() != null )
            {
                serializer.attribute( NAMESPACE, "name", logo.getName() );
            }
            if ( logo.getHref() != null )
            {
                serializer.attribute( NAMESPACE, "href", logo.getHref() );
            }
            if ( logo.getImg() != null )
            {
                serializer.attribute( NAMESPACE, "img", logo.getImg() );
            }
            if ( ( logo.getPosition() != null ) && !logo.getPosition().equals( "left" ) )
            {
                serializer.attribute( NAMESPACE, "position", logo.getPosition() );
            }
            if ( logo.getAlt() != null )
            {
                serializer.attribute( NAMESPACE, "alt", logo.getAlt() );
            }
            if ( logo.getBorder() != null )
            {
                serializer.attribute( NAMESPACE, "border", logo.getBorder() );
            }
            if ( logo.getWidth() != null )
            {
                serializer.attribute( NAMESPACE, "width", logo.getWidth() );
            }
            if ( logo.getHeight() != null )
            {
                serializer.attribute( NAMESPACE, "height", logo.getHeight() );
            }
            if ( logo.getTarget() != null )
            {
                serializer.attribute( NAMESPACE, "target", logo.getTarget() );
            }
            serializer.endTag( NAMESPACE, tagName );
        }
    } //-- void writeLogo( Logo, String, XmlSerializer )

    /**
     * Method writeMenu.
     * 
     * @param menu
     * @param serializer
     * @param tagName
     * @throws java.io.IOException
     */
    private void writeMenu( Menu menu, String tagName, XmlSerializer serializer )
        throws java.io.IOException
    {
        if ( menu != null )
        {
            serializer.startTag( NAMESPACE, tagName );
            if ( menu.getName() != null )
            {
                serializer.attribute( NAMESPACE, "name", menu.getName() );
            }
            if ( menu.getInherit() != null )
            {
                serializer.attribute( NAMESPACE, "inherit", menu.getInherit() );
            }
            if ( menu.isInheritAsRef() != false )
            {
                serializer.attribute( NAMESPACE, "inheritAsRef", String.valueOf( menu.isInheritAsRef() ) );
            }
            if ( menu.getRef() != null )
            {
                serializer.attribute( NAMESPACE, "ref", menu.getRef() );
            }
            if ( menu.getImg() != null )
            {
                serializer.attribute( NAMESPACE, "img", menu.getImg() );
            }
            if ( menu.getAlt() != null )
            {
                serializer.attribute( NAMESPACE, "alt", menu.getAlt() );
            }
            if ( ( menu.getPosition() != null ) && !menu.getPosition().equals( "left" ) )
            {
                serializer.attribute( NAMESPACE, "position", menu.getPosition() );
            }
            if ( menu.getBorder() != null )
            {
                serializer.attribute( NAMESPACE, "border", menu.getBorder() );
            }
            if ( menu.getWidth() != null )
            {
                serializer.attribute( NAMESPACE, "width", menu.getWidth() );
            }
            if ( menu.getHeight() != null )
            {
                serializer.attribute( NAMESPACE, "height", menu.getHeight() );
            }
            if ( ( menu.getItems() != null ) && ( menu.getItems().size() > 0 ) )
            {
                for ( Iterator iter = menu.getItems().iterator(); iter.hasNext(); )
                {
                    MenuItem o = (MenuItem) iter.next();
                    writeMenuItem( o, "item", serializer );
                }
            }
            serializer.endTag( NAMESPACE, tagName );
        }
    } //-- void writeMenu( Menu, String, XmlSerializer )

    /**
     * Method writeMenuItem.
     * 
     * @param menuItem
     * @param serializer
     * @param tagName
     * @throws java.io.IOException
     */
    private void writeMenuItem( MenuItem menuItem, String tagName, XmlSerializer serializer )
        throws java.io.IOException
    {
        if ( menuItem != null )
        {
            serializer.startTag( NAMESPACE, tagName );
            if ( menuItem.isCollapse() != false )
            {
                serializer.attribute( NAMESPACE, "collapse", String.valueOf( menuItem.isCollapse() ) );
            }
            if ( menuItem.getRef() != null )
            {
                serializer.attribute( NAMESPACE, "ref", menuItem.getRef() );
            }
            if ( menuItem.getName() != null )
            {
                serializer.attribute( NAMESPACE, "name", menuItem.getName() );
            }
            if ( menuItem.getHref() != null )
            {
                serializer.attribute( NAMESPACE, "href", menuItem.getHref() );
            }
            if ( menuItem.getImg() != null )
            {
                serializer.attribute( NAMESPACE, "img", menuItem.getImg() );
            }
            if ( ( menuItem.getPosition() != null ) && !menuItem.getPosition().equals( "left" ) )
            {
                serializer.attribute( NAMESPACE, "position", menuItem.getPosition() );
            }
            if ( menuItem.getAlt() != null )
            {
                serializer.attribute( NAMESPACE, "alt", menuItem.getAlt() );
            }
            if ( menuItem.getBorder() != null )
            {
                serializer.attribute( NAMESPACE, "border", menuItem.getBorder() );
            }
            if ( menuItem.getWidth() != null )
            {
                serializer.attribute( NAMESPACE, "width", menuItem.getWidth() );
            }
            if ( menuItem.getHeight() != null )
            {
                serializer.attribute( NAMESPACE, "height", menuItem.getHeight() );
            }
            if ( menuItem.getTarget() != null )
            {
                serializer.attribute( NAMESPACE, "target", menuItem.getTarget() );
            }
            if ( menuItem.getDescription() != null )
            {
                serializer.startTag( NAMESPACE, "description" ).text( menuItem.getDescription() ).endTag( NAMESPACE, "description" );
            }
            if ( ( menuItem.getItems() != null ) && ( menuItem.getItems().size() > 0 ) )
            {
                for ( Iterator iter = menuItem.getItems().iterator(); iter.hasNext(); )
                {
                    MenuItem o = (MenuItem) iter.next();
                    writeMenuItem( o, "item", serializer );
                }
            }
            serializer.endTag( NAMESPACE, tagName );
        }
    } //-- void writeMenuItem( MenuItem, String, XmlSerializer )

    /**
     * Method writePublishDate.
     * 
     * @param publishDate
     * @param serializer
     * @param tagName
     * @throws java.io.IOException
     */
    private void writePublishDate( PublishDate publishDate, String tagName, XmlSerializer serializer )
        throws java.io.IOException
    {
        if ( publishDate != null )
        {
            serializer.startTag( NAMESPACE, tagName );
            if ( publishDate.getPosition() != null )
            {
                serializer.attribute( NAMESPACE, "position", publishDate.getPosition() );
            }
            if ( ( publishDate.getFormat() != null ) && !publishDate.getFormat().equals( "yyyy-MM-dd" ) )
            {
                serializer.attribute( NAMESPACE, "format", publishDate.getFormat() );
            }
            serializer.endTag( NAMESPACE, tagName );
        }
    } //-- void writePublishDate( PublishDate, String, XmlSerializer )

    /**
     * Method writeSkin.
     * 
     * @param skin
     * @param serializer
     * @param tagName
     * @throws java.io.IOException
     */
    private void writeSkin( Skin skin, String tagName, XmlSerializer serializer )
        throws java.io.IOException
    {
        if ( skin != null )
        {
            serializer.startTag( NAMESPACE, tagName );
            if ( skin.getGroupId() != null )
            {
                serializer.startTag( NAMESPACE, "groupId" ).text( skin.getGroupId() ).endTag( NAMESPACE, "groupId" );
            }
            if ( skin.getArtifactId() != null )
            {
                serializer.startTag( NAMESPACE, "artifactId" ).text( skin.getArtifactId() ).endTag( NAMESPACE, "artifactId" );
            }
            if ( skin.getVersion() != null )
            {
                serializer.startTag( NAMESPACE, "version" ).text( skin.getVersion() ).endTag( NAMESPACE, "version" );
            }
            serializer.endTag( NAMESPACE, tagName );
        }
    } //-- void writeSkin( Skin, String, XmlSerializer )

    /**
     * Method writeVersion.
     * 
     * @param version
     * @param serializer
     * @param tagName
     * @throws java.io.IOException
     */
    private void writeVersion( Version version, String tagName, XmlSerializer serializer )
        throws java.io.IOException
    {
        if ( version != null )
        {
            serializer.startTag( NAMESPACE, tagName );
            if ( version.getPosition() != null )
            {
                serializer.attribute( NAMESPACE, "position", version.getPosition() );
            }
            serializer.endTag( NAMESPACE, tagName );
        }
    } //-- void writeVersion( Version, String, XmlSerializer )

}
